/*
 * Copyright 2012  Patrick Uiterwijk
 */
definition module ArgumentParser

from StdOverloaded import class toString, class ==

:: ArgumentType = FlagArgument | StringValueArgument | IntValueArgument
:: ArgumentName :== String
:: ArgumentDescription :== String
:: Argument :== (ArgumentName, ArgumentType, ArgumentDescription)
:: ArgumentValue = ArgumentUnset | ArgumentSet | ArgumentStringValue String | ArgumentIntValue Int
:: ArgumentParserState

initializeArgumentParser :: ArgumentParserState
setProgramName :: ArgumentParserState String -> ArgumentParserState
setProgramDescription :: ArgumentParserState String -> ArgumentParserState
addValidArgument :: ArgumentParserState Argument -> ArgumentParserState
parseArguments :: ArgumentParserState -> (ArgumentName -> ArgumentValue)
showHelp :: ArgumentParserState -> String

instance toString ArgumentValue
instance == ArgumentValue
